package com.zt.plat.module.qms.resource.record.service.recordRelation;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.resource.record.controller.admin.recordRelation.vo.RecordRelationPageReqVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordRelation.vo.RecordRelationRespVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordRelation.vo.RecordRelationSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;

import com.zt.plat.module.qms.resource.record.dal.dataobject.recordRelation.RecordRelationDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.resource.record.dal.mapper.RecordRelationMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 文件记录关系 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class RecordRelationServiceImpl implements RecordRelationService {

    @Resource
    private RecordRelationMapper recordRelationMapper;

    @Override
    public RecordRelationRespVO createRecordRelation(RecordRelationSaveReqVO createReqVO) {
        // 插入
        RecordRelationDO recordRelation = BeanUtils.toBean(createReqVO, RecordRelationDO.class);
        recordRelationMapper.insert(recordRelation);
        // 返回
        return BeanUtils.toBean(recordRelation, RecordRelationRespVO.class);
    }

    @Override
    public void updateRecordRelation(RecordRelationSaveReqVO updateReqVO) {
        // 校验存在
        validateRecordRelationExists(updateReqVO.getId());
        // 更新
        RecordRelationDO updateObj = BeanUtils.toBean(updateReqVO, RecordRelationDO.class);
        recordRelationMapper.updateById(updateObj);
    }

    @Override
    public void deleteRecordRelation(String id) {
        // 校验存在
        validateRecordRelationExists(id);
        // 删除
        recordRelationMapper.deleteById(id);
    }

    @Override
        public void deleteRecordRelationListByIds(List<String> ids) {
        // 校验存在
        validateRecordRelationExists(ids);
        // 删除
        recordRelationMapper.deleteByIds(ids);
        }

    private void validateRecordRelationExists(List<String> ids) {
        List<RecordRelationDO> list = recordRelationMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(RECORD_RELATION_NOT_EXISTS);
        }
    }

    private void validateRecordRelationExists(String id) {
        if (recordRelationMapper.selectById(id) == null) {
            throw exception(RECORD_RELATION_NOT_EXISTS);
        }
    }

    @Override
    public RecordRelationDO getRecordRelation(String id) {
        return recordRelationMapper.selectById(id);
    }

    @Override
    public PageResult<RecordRelationDO> getRecordRelationPage(RecordRelationPageReqVO pageReqVO) {
        return recordRelationMapper.selectPage(pageReqVO);
    }

}